%define mainname nessus
%define name    %{mainname}
%define version 1.1.4
%define release 1mdk
%define prefix  %{_prefix}

Name:		%{name}
Summary:	Nessus security scanner
Version:	%{version}
Release:	%{release}
License:	GPL
Group:		System/Servers
URL:		http://www.nessus.org/
Source1:	nessus-libraries-%{version}.tar.bz2
Source2:	libnasl-%{version}.tar.bz2
Source3:	nessus-core-%{version}.tar.bz2
Source4:	nessus-plugins-%{version}.tar.bz2
Source5:	nessusd.init.bz2
Source6:	nessusd.users.bz2
Source7:	nessusd.rules.bz2
Source8:	nessusd.conf.bz2
Source9:	plugins_api.txt.bz2
Source10:       nessus-16.xpm.bz2
Source11:       nessus-32.xpm.bz2
Source12:       nessus-48.xpm.bz2
Prefix:         %{prefix}
Requires:	nmap
BuildRoot:	%{_tmppath}/%{name}-buildroot

%description
Nessus is a free, up-to-date, and full featured remote security scanner for
Linux. It is multithreaded, plugin-based, has a nice GTK interface, and
currently performs 410 remote security checks. It has powerful reporting
capabilities (HTML, LaTeX, ASCII text) and not only points out problems,
but suggests a solution for each of them.

%package devel
Group:		System/Libraries
Summary:	Development libraries and headers for Nessus.
%description devel
Development libraries and headers for Nessus.


%package client
Group:		Monitoring
Summary:	Nessus GTK+ client.
%description client
Nessus Gtk+ client.


%package plugins
Group:		System/Servers
Summary:	Nessus plugins.
Requires:	%{name}
%description plugins
Nessus plugins.


%prep
rm -rf $RPM_BUILD_ROOT

%setup -q -c -T
%setup -q -T -D -a 1
%setup -q -T -D -a 2
%setup -q -T -D -a 3
%setup -q -T -D -a 4
perl -pi -e 's/^installuser=.*/installuser='`whoami`'/' nessus-core/nessus.tmpl.in
bzip2 -cd %{SOURCE9} > ./`basename %{SOURCE9} .bz2`

%build
if [ -d %buildroot ]; then rm -rf %buildroot; fi
mkdir -p %buildroot{%{_bindir},%{_libdir}/%{name}/reports,%{_sysconfdir}/nessus,%{_initrddir},%{_var}/log/nessus}

# Build and install nessus libraries
(cd nessus-libraries; \
 CFLAGS="%optflags" ac_cv_prog_cc_g=no ac_cv_prog_cxx_g=no \
 ./configure --enable-cipher --enable-zlib --prefix=%{_prefix}; \
 perl -pi -e 's/-o root / /g; s/-o \$\(installuser\) / /g; y/{}/()/' Makefile; \
 make && make install prefix=%buildroot%{_prefix})
perl -pi -e 's|^PREFIX=.*|PREFIX='%buildroot%{_prefix}'|;
             s|-I/usr/include/peks|-I\$\INCLUDEDIR/peks|;' %buildroot%{_bindir}/nessus-config

# Build and install nasl
(cd libnasl; \
 PATH="%buildroot%{_bindir}:$PATH" \
 CFLAGS="%optflags" \
 LD_LIBRARY_PATH="%buildroot%{_libdir}:$LD_LIBRARY_PATH" \
 ac_cv_prog_cc_g=no ac_cv_prog_cxx_g=no ./configure --prefix=%{_prefix}; \
 perl -pi -e 's/-o root / /g; s/-o \$\(installuser\) / /g; y/{}/()/' Makefile; \
 make && make install prefix=%buildroot%{_prefix})
perl -pi -e 's|^PREFIX=.*|PREFIX='%buildroot%{_prefix}'|' %buildroot%{_bindir}/nasl-config

# Build and install nessus-core
(cd nessus-core; \
 perl -pi -e 's|^NESSUSD_CONFDIR=.*|NESSUSD_CONFDIR=%{_sysconfdir}/|;
              s|^NESSUSD_STATEDIR=.*|NESSUSD_STATEDIR=%{_var}/log/nessus|;
              s|^NESSUSD_DATADIR=.*|NESSUSD_DATADIR=%{_sysconfdir}/nessus|;' ./configure;\
 PATH="%buildroot%{_bindir}:$PATH" \
 CFLAGS="%optflags" \
 LD_LIBRARY_PATH="%buildroot%{prefix}/lib:$LD_LIBRARY_PATH" \
 ac_cv_prog_cc_g=no ac_cv_prog_cxx_g=no \
 ./configure --prefix=%{_prefix} --sysconfdir=%{_sysconfdir} \
   --localstatedir=%{_var}/log --datadir=%{_sysconfdir} \
   --enable-release --enable-pthreads --enable-cipher \
   --includedir=%buildroot%{_prefix}/include; \
 perl -pi -e 's/-o root / /g; s/-o \$\(installuser\) / /g; y/{}/()/' Makefile; \
 make && make install prefix=%buildroot%{_prefix} \
   sysconfdir=%buildroot%{_sysconfdir} localstatedir=%buildroot%{_var}/log \
   datadir=%buildroot%{_sysconfdir} \
   NESSUSD_CONFDIR=%buildroot%{_sysconfdir}/ \
   NESSUSD_STATEDIR=%buildroot%{_var}/log/nessus \
   NESSUSD_DATADIR=%buildroot%{_sysconfdir}/nessus)

# Build and install nessus-plugins
(cd nessus-plugins; \
 PATH="%buildroot%{_bindir}:$PATH" \
 CFLAGS="%optflags" \
 LD_LIBRARY_PATH="%buildroot/%{_libdir}:$LD_LIBRARY_PATH" \
 ac_cv_prog_cc_g=no ac_cv_prog_cxx_g=no \
 ./configure --prefix=%{_prefix}; \
 perl -pi -e 's/-o root / /g; s/-o \$\(installuser\) / /g; y/{}/()/' Makefile; \
 make && make install prefix=%buildroot%{_prefix} \
   sysconfdir=%buildroot%{_sysconfdir} libdir=%buildroot%{_libdir} \
   localstatedir=%buildroot%{_var}/log datadir=%buildroot%{_sysconfdir})

%install
mkdir -p %buildroot{%{_bindir},%{_libdir}/%{name}/reports,%{_sysconfdir}/nessus,%{_initrddir},%{_var}/log/nessus}
# Main Install already done in build
# for dir in nessus-libraries libnasl nessus-core nessus-plugins; do
# (cd $dir; make install prefix=%buildroot/%{_prefix} \
#  sysconfdir=%buildroot%{_sysconfdir}/nessus localstatedir=%buildroot%{_var} \
#  datadir=%buildroot%{_sysconfdir})
# done
bzip2 -cd %{SOURCE5} > %buildroot%{_initrddir}/nessusd
for file in %{SOURCE6} %{SOURCE7} %{SOURCE8} ; do
    bzip2 -cd $file > %buildroot%{_sysconfdir}/nessus/$(basename $file .bz2)
done
#install %{SOURCE14} %buildroot%{_libdir}/nessus/plugins/
#install %{SOURCE15} %buildroot%{_libdir}/nessus/plugins/
#install %{SOURCE16} %buildroot%{_libdir}/nessus/plugins/

# move man files to the FHS compliant location
mkdir -p %buildroot%{_mandir}
mv %buildroot%{_prefix}/man/* %buildroot%{_mandir}

# clean-up man files
for i in %{_mandir}/man8/nessusd.8; do
        perl -pi -e 's|'%buildroot%{_sysconfdir}/nessusd.conf'|%{_sysconfdir}/nessus/nessusd.conf|g' %buildroot/$i
done
 
# Correct paths in devel stuff
perl -pi -e 's|^PREFIX=.*|PREFIX='%{_prefix}'|' \
 %buildroot%{_bindir}/*-config \

# manually install docs
mkdir -p %buildroot%{_docdir}/%{name}-%{version}
cp -av $RPM_BUILD_DIR/%{name}-%{version}/%{name}-core/{CHANGES,INSTALL,README_LINUX,TODO,UPGRADE_README} %buildroot%{_docdir}/%{name}-%{version}

# Add menu entry for client
mkdir -p %buildroot%{_menudir}
cat > %buildroot%{_menudir}/%{mainname}-client << EOF
?package(%{mainname}-client): \
    command="%{_bindir}/nessus" \
    title="Nessus" \
    longtitle="Nessus Security Scanner" \
    section="Applications/Monitoring" \
    icon="nessus.xpm" \
    needs="X11"
EOF

# Install icons
mkdir -p %buildroot{%{_miconsdir},%{_iconsdir},%{_liconsdir}}
bzip2 -dc %{SOURCE10} > %buildroot%{_miconsdir}/nessus.xpm
bzip2 -dc %{SOURCE11} > %buildroot%{_iconsdir}/nessus.xpm
bzip2 -dc %{SOURCE12} > %buildroot%{_liconsdir}/nessus.xpm

%clean
if [ -d %buildroot ]; then rm -rf %buildroot; fi
rm -rf $RPM_BUILD_DIR/%{name}-%{version}

%post
#set -x
perl -pi -e 's|\@RPM_INSTALL_PREFIX\@|'${RPM_INSTALL_PREFIX}'|' \
 %{_initrddir}/nessusd %{_sysconfdir}/nessus/nessusd.conf

if [ $1 = 1 ]; then
	chkconfig --add nessusd
	%{_initrddir}/nessusd start
else
	%{_initrddir}/nessusd restart
fi
#set +x
/sbin/ldconfig


%preun
#set -x
if [ $1 = 0 ]; then
	%{_initrddir}/nessusd stop
	chkconfig --del nessusd
fi
#set +x

%postun -p /sbin/ldconfig

%post client 
/sbin/ldconfig
%{update_menus}

%postun client 
/sbin/ldconfig
%{clean_menus}

%files
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/*
%attr(0755,root,root) %{_libdir}/*.so*
%attr(0755,root,root) %{_sbindir}/nessusd
%attr(0755,root,root) %{_sbindir}/nessus-adduser
%dir %{_sysconfdir}/nessus
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/nessus/accounts.txt
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/nessus/nessusd.conf
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/nessus/nessusd.rules
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/nessus/nessusd.users
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/nessus/queso.conf
%dir %{_var}/log/nessus
%attr(0755,root,root) %config %{_initrddir}/nessusd
%{_mandir}/man8/*

%files devel
%defattr(0644,root,root,755)
%doc plugins_api.txt
%{_prefix}/include/*
%{_libdir}/*.*a
%attr(0755,root,root) %{_bindir}/nessus-config
%attr(0755,root,root) %{_bindir}/nasl-config

%files client
%defattr(0644,root,root,755)
%attr(0755,root,root) %{_bindir}/nessus
%attr(0755,root,root) %{_libdir}/libnessus.so*
%doc %{_mandir}/man1/*
%dir %{_libdir}/nessus/reports
%{_menudir}/*
%{_miconsdir}/*xpm
%{_iconsdir}/*xpm
%{_liconsdir}/*xpm

%files plugins
%defattr(0644,root,root,0755)
%{_libdir}/nessus/plugins/*

%changelog
* Mon Sep 17 2001 Lenny Cartier <lenny@mandrakesoft.com> 1.1.4-1mdk
- added by Oden Eriksson <oden.eriksson@kvikkjokk.net> :
	- updated to 1.1.4

* Tue Aug 21 2001 Lenny Cartier <lenny@mandrakesoft.com> 1.0.9-1mdk
- updated to 1.0.9

* Wed Jun  6 2001 Laurent Culioli <laurent@mandrakesoft.com> 1.0.8-1mdk
- updated to 1.0.8

* Wed Mar 07 2001  Lenny Cartier <lenny@mandrakesoft.com> 1.0.7a-1mdk
- upgraded to 1.0.7a

* Tue Jan 30 2001 Lenny Cartier <lenny@mandrakesoft.com> 1.0.7-1mdk
- used srpm from Guillaume Rousse <g.rousse@mandrake-linux.com> :
	- updated to 1.0.7

* Mon Nov 06 2000 Lenny Cartier <lenny@mandrakesoft.com> 1.0.5-1mdk
- used srpm from Alexander Skwar <ASkwar@Linux-Mandrake.com> :
	New version
	Added menu for the client with icons
	Quiet the unpacking of the files

* Wed Jul 26 2000 John Johnson <jjohnson@linux-mandrake.com> 1.0.3-1mdk
- Fixed an error in my spec file that caused the nessusd script in
  /etc/rc.d/init.d to not work properly.

* Wed Jul 12 2000 John Johnsin <jjohnson@linux-mandrake.com> 1.0.3-1mdk
- Updated rpm for version 1.0.3 
- made a few small changes to spec file

* Sat Jun 10 2000 John Johnson <jjohnson@linux-mandrake.com> 1.0.1-1mdk
- updated sources to the new version.

* Mon May 29 2000 Vincent Danen <vdanen@linux-mandrake.com> 1.0.0-2mdk
- bzip sources
- fix group
- various specfile cleanups
- made unrelocatable
- added call to ldconfig in post and postun

* Thu May 18 2000 John Johnson <jjohnson@linux-mandrake.com>
- Made Mandrake rpm
